"""
  Zamysel: analiz PE-EXE - podprogrammy.

  Ispolxz. http://cs.usu.edu.ru/docs/pe/ -> lukac.zip .

  Zame`.: dlq nek-ryh struktur w fajle adresa hranqtsq 
ne fizi`eskie (w fajle), a wirtualxnye (w pamqti posle zagruzki),
po\tomu na stadii nahovdeniq sekcij nado stroitx tabl. perehoda
ot wirt. k real. adresam.
  Zame`.: sekcii .idata i .edata wrode realxno ni razu ne wstretilisx, 
a import i \\ksport osu]. `erez razdely EXPORT i IMPORT 
w tablice katalogow - sm. lukac.zip -> dirs1.htm, 
razdely 5.2 i 5.3.

  2022,12,15: predprinqta popytka wmesto 
tabl_VA_A ispolxzowatx tabl_sekcij s .sort(),
w nadevde na bOlx[u; nagladnostx, no ne dodelano.
  Teku[. sost.: w prostyh slu`aqh rabotaet, no inogda
-> na stadii VA_A -> adres nerealen, i ne uda@tsq wosstanowitx
imena funkcij i t.p.
"""
from obscie import *
import os,sys

def set_whodn(imq0_):
 """
 imq0 - imq whodn. fajla.
 """
 global imq0,l_fajla
 # print 'set_whodn: imq0 = %s' % (repr(imq0_),)
 imq0 = imq0_
 l_fajla = set_whodn_(imq0_)


# Sm. lukac.zip, dirs1.htm, tabl. w razd. 5.1.
obozn=[
 'EXPORT','IMPORT','RESOURCE','EXCEPTION',
 'SECURITY','BASERELOC','DEBUG','ARCHITECTURE',
 'GLOBALPTR','TLS','LOAD_CONFIG','BOUND_IMPORT',
 'IAT','DELAY_IMPORT','COM_DESCRIPTOR','Reserved',
]

# tabl_VA_A - tabl. perekodir. VirtAddr -> Addr;
# predlag. stroenie \l-tow - (name,VirtAddr,Siz,Addr).

tabl_VA_A=[]
tabl_sekcij=[]
tabl_katalogow=[]

def anal_header():
 global ofs_PE,n_sect,SizOfOptHea,entry_point_VA

 print '----- anal_header -----\\'
 s=ww_ofs(0x3C,4,'ofs_PE')
 ofs_PE,=unpack('<L',s)
 print 'ofs_PE=%08X' % (ofs_PE,)

 print "\n~tenie osnownogo PE-header'a.\n"

 s=ww_ofs(ofs_PE,0x18,'PE',otlad=True)
 signat,machine,n_sect,date,PoiToSymTab=unpack('<4sHHLL',s[:0x10])
 assert signat[:2]=='PE'
 NumbOfSymb,SizOfOptHea,Chara=unpack('<LHH',s[0x10:0x18])

 print '%8X - machine'     % (machine,)
 assert machine==0x014C  # Dlq 32-razr.; dlq 64-razr. - 0x8664 !
 print '%8X - n_sect'      % (n_sect,)
 print '%8X - SizOfOptHea' % (SizOfOptHea,)
 assert SizOfOptHea==0xE0  # Dlq 32-razr.; dlq 64-razr. - 0xF0 !

 print "\n~tenie t.n. Optional Header'a - na`alo.\n"

 ofs_OptHea=ofs_PE+0x18
 s=ww_ofs(ofs_OptHea,8,'OptHea+0',otlad=True)
 Mag,Ver,SizCode=unpack('<HHL',s)
 assert Mag==0x010B

 s=ww_ofs(ofs_OptHea+0x8,0x20,'OptHea+8',otlad=True)
 siz_data,siz_bss,entry_point_VA,ofs_code,\
   ofs_data,ImageBase,LoadAlign,FileAlign=\
   unpack('<LLLLLLLL',s)

 s=ww_ofs(ofs_OptHea+0x28,0x20,'OptHea+28',otlad=True)
 MajorOSVers,MinorOSVers,SubsystVers,reserv1,\
  SizOfImage,SizOfHeaders,CheckSum,GUI,DLL_Char=\
  unpack('<LLLLLLLHH',s)
 assert GUI in [2,3]  # 2 - grafi`., 3 - konsolxn.

 s=ww_ofs(ofs_OptHea+0x48,0x18,'OptHea+48',otlad=True)
 # dump4(ofs_OptHea+0x48,s)
 """
   PE+60 == OptHea+48. T.o., izwlek. sled. weli`iny:
 48 4 SizStackReserv,
 4C 4 SizStackCommit,
 50 4 SizHeapReserv,
 54 4 SizHeapCommit,\
 58 4 LoaderFlags,
 5C 4 SizDataDir, wsegda =16.
   Dalee id@t:
 60 128 ImageDataDirectory[16]; kavdyj - VirtAddr i Size (4+4 bajta).
 """
 SizStackReserv,SizStackCommit,SizHeapReserv,SizHeapCommit,\
   LoaderFlags,SizDataDir=unpack('<LLLLLL',s)
 print '%8X - SizDataDir' % (SizDataDir,)
 assert SizDataDir==16

 print '----- Prosmotr kataloga dannyh - na`alo -----\\'
 for i in range(16):
  ofse=ofs_OptHea+0x60+8*i
  s=ww_ofs(ofse,8,'DataDir['+str(i)+']',otlad=True)
  VA,siz_=unpack('<LL',s)

  # if i==0: p1V,p2 = VA,siz_  # Sekciq EXPORT - dlq posledu;]ego analiza.
  tabl_katalogow.append((VA,siz_))
  # i=0 -> EXPORT, i=1 -> IMPORT, ... .

  if VA!=0 or siz_!=0:
   print '%2d %-12s %8X %8X' % (i,obozn[i],VA,siz_)

 print '----- Prosmotr kataloga dannyh - konec  -----/'

 print "\n~tenie t.n. Optional Header'a - konec.\n"

 print '----- anal_header -----/'


def anal_sekcij():
 global ofs_OpisSekcij
 print '----- anal_sekcij -----\\'
 print '\nNa`alo prosmotra sekcij.\n'

 ofs_OpisSekcij = ofs_PE+0x18+SizOfOptHea
 print 'ofs_OpisSekcij= %08X + 0x18 + %08X = %08X' % \
   (ofs_PE,SizOfOptHea,ofs_OpisSekcij)

 print 'n_sect=',n_sect
 for i in range(n_sect):
  s=ww_ofs(ofs_OpisSekcij+i*0x28,0x28,'Sekciq',otlad=True)
  # dump16(ofs_OpisSekcij+i*0x28,s)
  name,VirtSiz,VirtAddr,Siz,Addr,pr,pln,nr,nln,flags=\
    unpack('<8sLLLLLLHHL',s)
  if ord(name[0])==0: print 'ord(name[0])==0 !!!'; break
  if Siz>l_fajla: print 'Siz>l_fajla !!!'; break

  # print name,VirtSiz,VirtAddr,Siz,Addr
  while name.endswith(chr(0)): name=name[:-1]
  # pr - pointer to Reloc., pln - pointer to Line Numbers,
  # nr - n of Reloc., nln - n of Line Numbers;
  # ne ispolxzu;tsq!
  tabl_VA_A.append((name,VirtAddr,Siz,Addr))

  tabl_sekcij.append((VirtAddr,VirtSiz,Addr,Siz,name))

  # print tabl_VA_A[-1]
  # karta_mark(Addr,Addr+Siz,mark_simw[i], imq=name)
  while name and name[-1]==chr(0): name=name[:-1]
  print '%2d %-8s %X (%X..%X) -> %X (%X..%X)' % \
    (i,name, Siz,Addr,Addr+Siz, VirtSiz,VirtAddr,VirtAddr+VirtSiz)

 print '\nKonec prosmotra sekcij.\n'
 print '----- anal_sekcij -----/'

def prosm_sekcij():
 print '----- prosm_sekcij -----\\'
 print '\nProsmotr sodervimogo sekcij - na`alo.\n'

 print 'n_sect=',n_sect
 for i in range(n_sect):
  """
  s=ww_ofs(ofs_OpisSekcij+i*0x28,0x28,'Sekciq',otlad=True)
  name,VirtSiz,VirtAddr,Siz,Addr,pr,pln,nr,nln,flags=\
    unpack('<8sLLLLLLHHL',s)
  if ord(name[0])==0: break
  while name and name[-1]==chr(0): name=name[:-1]
  """
  VirtAddr,VirtSiz,Addr,Siz,name = tabl_sekcij[i]
  s_=ww_ofs(Addr,Siz,name,otlad=True)

 print '\nProsmotr sodervimogo sekcij - konec.\n'
 print '----- prosm_sekcij -----/'

"""
def print_tabl_VA_A():
 print '----- print_tabl_VA_A -----\\'
 ft = '%-12s %08X %08X  %04X'
 print ' imq            VA      dlina      A'
 for x in tabl_VA_A:
  print ft % x
 print '----- print_tabl_VA_A -----/'
"""

def print_tabl_sekcij():
 print '\n----- print_tabl_sekcij -----\\'
 ft = ' %08X %08X   %08X %08X   %-12s'
 print '    VA       VS          A       S        imq'
 for i in range(n_sect):
  VirtAddr,VirtSiz,Addr,Siz,name = tabl_sekcij[i]
  print ft % tabl_sekcij[i]
 print '----- print_tabl_sekcij -----/\n'

def print_tabl_katalogow():
 print '----- print_tabl_katalogow -----\\'
 ft = '%2d %-12s %08X %08X %08X %08X'
 print ' i  obozn[i]       VA      siz_       A     A+siz'
 for i in range(16):
  VA,siz_ = tabl_katalogow[i]
  if VA==0 and siz_==0: continue
  A = VA_A(VA, otlad=False)
  print ft % (i,obozn[i],VA,siz_,A,A+siz_)
 print '----- print_tabl_katalogow -----/'

def VA_A(VA, otlad=True):
 if otlad: print 'VA_A: VA=%08X' % (VA)
 A=None
 for i in range(len(tabl_VA_A)):
  (name,VA0,Siz,A0)=tabl_VA_A[i]
  if otlad: print '%08X / %8s / %08X %08X..%08X / %08X..%08X' % \
    (VA,name,Siz, VA0,VA0+Siz, A0,A0+Siz)
  if VA>=VA0 and VA<VA0+Siz: A=VA-VA0+A0; break
 if A==None:
  print 'VA_A - err.: VA=%08X !!!' % (VA)
  i=0; i=1/i
 else:
  if otlad: print 'VA_A: VA,name,A=%08X %-8s %08X' % (VA,name,A)
 return(A)   

def anal_IMAGE_EXPORT_DIRECTORY():
 print '\n----- anal_IMAGE_EXPORT_DIRECTORY -----\\\n'

 p1V,dlina = tabl_katalogow[0]
 if dlina==0: 
  print 'Razdel EXPORT otsutstwuet.'
  print '----- anal_IMAGE_EXPORT_DIRECTORY -----/\n'
  return

 p1=VA_A(p1V, otlad=False)  # RVA -> FileOfs .
 print 'p1V,p1,dlina,p1+dlina = %08X %08X %08X %08X' % (p1V,p1,dlina,p1+dlina) 
 s=ww_ofs(p1,dlina,'export',otlad=True)
 # dump4(p1,s,'p1')
 s_=s[:0x28]
 unused,TimeDate,version,adr_name_,base,\
   n_funcs,n_names,VA_tabl_funcs,VA_tabl_names,VA_tabl_ordinals=\
   unpack('<LLLLLLLLLL',s_)

 adr_name=VA_A(adr_name_,otlad=False)
 # f0.seek(adr_name)
 imq_dll = ww_str_end0(adr_name)
 print 'imq_dll = %08X %s' % (adr_name,repr(imq_dll))

 print '%8X - n_funcs'   % (n_funcs,)
 print '%8X - n_names'   % (n_names,)
 adr_tabl_funcs    = VA_A(VA_tabl_funcs,otlad=False)
 adr_tabl_names    = VA_A(VA_tabl_names,otlad=False)
 adr_tabl_ordinals = VA_A(VA_tabl_ordinals,otlad=False)
 print '%8X - adr_tabl_funcs'   % (adr_tabl_funcs,)
 print '%8X - adr_tabl_names'   % (adr_tabl_names,)
 print '%8X - adr_tabl_ordinals' % (adr_tabl_ordinals,)

 end_tabl_ordinals = adr_tabl_ordinals + 2*n_names
 print '%8X - end_tabl_ordinals' % (end_tabl_ordinals,)

 print '\nTablica funkcij:'
 print '  i    a4       VA       A       dump' 
 for i in range(n_funcs):
  a4=adr_tabl_funcs+4*i
  # print '-'*8
  # print 'i,a4=%3d %08X' % (i,a4)
  sx=ww_ofs(a4,4,'adr_funcs',otlad=False)
  adr_funcs_,=unpack('<L',sx)
  if adr_funcs_==0: continue

  # print 'adr_funcs_= %08X' % (adr_funcs_,)

  # Stranno - inogda popadaet w oblastx dannyh ili nulej.
  # if i<=12: adr_funcs = VA_A(adr_funcs_,otlad=True)
  # else:     adr_funcs = VA_A(adr_funcs_,otlad=False)
  try:
   adr_funcs = VA_A(adr_funcs_,otlad=False)
  except:
   print '%3d %08X %08X -> VA_A -> err.!' % (i,a4,adr_funcs_)
   continue

  s1=ww_ofs(adr_funcs,8,'func',otlad=False)
  s2=dump_s(s1[:8])
  print '%3d %08X %08X %08X %s' % (i,a4,adr_funcs_,adr_funcs,s2)
 print

 print '\nTablica im@n:'
 print '  i  ord  adr_names    imq'
 for i in range(n_names):
  a4a=adr_tabl_names+4*i
  a4b=adr_tabl_ordinals+2*i
  sx=ww_ofs(a4a,4,'adr_names',otlad=False)
  adr_names_,=unpack('<L',sx)
  adr_names = VA_A(adr_names_,otlad=False)
  # print 'adr_names_,adr_names= %08X %08X' % (adr_names_,adr_names)
  sx=ww_ofs(a4b,2,'adr_n',otlad=False)
  n,=unpack('<H',sx)
  imq=ww_str_end0(adr_names)
  print '%3d  %3d  %08X  %s' % (i,n,adr_names,imq)

 print '\n----- anal_IMAGE_EXPORT_DIRECTORY -----/\n'

def anal_tabl_imxn_importa(A, otlad=False):
 print '----- anal_tabl_imxn_importa -----\\'
 i=-1
 while True:
  i+=1
  A_ = A+4*i
  s = ww_ofs(A_,4,'tabl_imxn',otlad=otlad) 
  assert len(s)==4
  n, = unpack('L',s) 
  if otlad: print '%d %08X' % (i,n)
  if n==0: break
  is_name = n & 0x80000000==0
  if is_name:
   try:
    A_name = VA_A(n, otlad=False)
   except:
    print 'VA_A: n=%08X !!!' % (n,) 
    continue
   if otlad: print 'n,A_name=%08X %08X' % (n,A_name)
   s_hint = ww_ofs(A_name,2,'hint',otlad=False)
   hint, = unpack('H',s_hint)
   name = ww_str_end0(A_name+2)
   assert len(name)<255
   print '%3d %08X %08X %04X %s' % (i,n,A_name,hint,repr(name))
  else:
   nomer = n & 0x7FFFFFFF
   print '%3d %08X nomer=%08X' % (i,n,nomer)
 print '----- anal_tabl_imxn_importa -----/'

def anal_tabl_adre_importa(A):
 print '----- anal_tabl_adre_importa -----\\'
 i=-1
 while True:
  i+=1
  A_ = A+4*i
  s = ww_ofs(A_,4,'tabl_adre',otlad=False) 
  assert len(s)==4
  n, = unpack('L',s) 
  if n==0: break
  print '%3d %08X' % (i,n)
 print '----- anal_tabl_adre_importa -----/'


def anal_IMAGE_IMPORT_DIRECTORY():
 """
 lukac.zip -> dirs1.htm, razdel 5.3.1.
 Ukaz., `to w NameTable i w IAT w zapisqh m.b. =1 star[ij bit,
 i togda \to ne ukaz. na imena, a nomera - dlq importa po nomeram!   
 """
 print '\n----- anal_IMAGE_IMPORT_DIRECTORY -----\\'

 p1V,dlina = tabl_katalogow[1]

 print 'p1V,dlina= %08X %08X' % (p1V,dlina)

 if dlina==0: 
  print 'Razdel IMPORT otsutstwuet.'
  print '----- anal_IMAGE_IMPORT_DIRECTORY -----/\n'
  return

 p1=VA_A(p1V, otlad=False)  # RVA -> FileOfs .
 print 'p1V,p1,dlina,p1+dlina = %08X %08X %08X %08X' % (p1V,p1,dlina,p1+dlina) 

 n_DLL_max = dlina/0x14  # S otbrasywaniem ostatka.
 # Priznak konca tablicy DLL - poslednie 0x14 bajtow ==0.  

 print 'n_DLL_max=',n_DLL_max
 for i_DLL in range(n_DLL_max):
  print '-'*8
  print 'i_DLL,n_DLL_max=',i_DLL,n_DLL_max
  p_ = p1+i_DLL*0x14
  s=ww_ofs(p_,0x14,'import DLL',otlad=True)

  VA_NameTable,DateTime,Forwarder,VA_NameDLL,VA_IAT=\
    unpack('<LLLLL',s)

  print 'VA_NameTable etc. = %08X %08X %08X %08X %08X' % \
    (VA_NameTable,DateTime,Forwarder,VA_NameDLL,VA_IAT)
  if VA_NameTable==0: 
   print 'Konec tablicy DLL.\n'
   break

  print '--------'

  print 'VA_NameDLL = %08X' % (VA_NameDLL,)
  try:
   A_NameDLL = VA_A(VA_NameDLL, otlad=False)
   print 'A_NameDLL = %08X' % (A_NameDLL,)
   imq_DLL = ww_str_end0(A_NameDLL)
   print 'imq_DLL=',repr(imq_DLL)
  except:
   print 'VA_A -> err.: VA_NameDLL=%08X !!!' % (VA_NameDLL,)
  print

  print 'VA_NameTable = %08X' % (VA_NameTable,)
  try:
   A_NameTable = VA_A(VA_NameTable, otlad=False)
   print 'A_NameTable = %08X' % (A_NameTable,)
   anal_tabl_imxn_importa(A_NameTable)
  except:
   print 'VA_A -> err.: VA_NameTable=%08X !!!' % (VA_NameTable,)
  print

  print 'VA_IAT = %08X' % (VA_IAT,)
  try:
   A_IAT = VA_A(VA_IAT, otlad=False)
   print 'A_IAT = %08X' % (A_IAT,)
   anal_tabl_adre_importa(A_IAT)
  except:
   print 'VA_A -> err.: VA_IAT=%08X !!!' % (VA_IAT,)
  print

 print '----- anal_IMAGE_IMPORT_DIRECTORY -----/\n'


def anal_entry():
 print '\n----- anal_entry -----\\'
 A = VA_A(entry_point_VA, otlad=False)
 if A!=None:
  s1=ww_ofs(A,8,'entry',otlad=False)
  s2=dump_s(s1[:8])
  print 'VA,A,damp= %08X %08X %s' % (entry_point_VA,A,s2)
 else:
  print 'VA,A= %08X %s' % (entry_point_VA,A)
 print '----- anal_entry -----/\n'

# --------

if __name__=='__main__':
 ss=dir()
 for s in ss: print s


'''
from karta import karta_sozd,karta_mark,karta_show
mark_simw='123456789ABCDEFxxxxx'  # Dlq izobraveniq karty razdelow.
print 'imq=',imq
stati=os.stat(imq)
l_fajla=stati.st_size
karta_sozd(l_fajla)
karta_show()

'''

